# SHEBANQ
[![SWH](https://archive.softwareheritage.org/badge/origin/https://github.com/ETCBC/shebanq/)](https://archive.softwareheritage.org/browse/origin/https://github.com/ETCBC/shebanq/)
[![DOI](https://zenodo.org/badge/14582815.svg)](https://zenodo.org/badge/latestdoi/14582815)

![shebanq2](https://raw.github.com/etcbc/shebanq/master/static/images/shebanq_logo.png)
![shebanq](https://raw.github.com/etcbc/shebanq/master/static/images/shebanq.png)

[![etcbc](static/images/etcbc.png)](http://www.etcbc.nl)
[![dans](static/images/dans.png)](https://dans.knaw.nl/en)
[![tf](static/images/tf-small.png)](https://annotation.github.io/text-fabric/tf)

### BHSA Family

* [bhsa](https://github.com/etcbc/bhsa) Core data and feature documentation
* [phono](https://github.com/etcbc/phono) Phonological representation of Hebrew words
* [parallels](https://github.com/etcbc/parallels) Links between similar verses
* [valence](https://github.com/etcbc/valence) Verbal valence for all occurrences
  of some verbs
* [trees](https://github.com/etcbc/trees) Tree structures for all sentences
* [bridging](https://github.com/etcbc/bridging) Open Scriptures morphology
  ported to the BHSA
* [pipeline](https://github.com/etcbc/pipeline) Generate the BHSA and SHEBANQ
  from internal ETCBC data files
* [shebanq](https://github.com/etcbc/shebanq) Engine of the
  [shebanq](https://shebanq.ancient-data.org) website

## About

*System for HEBrew Text: ANnotations for Queries and Markup*

[SHEBANQ](http://shebanq.ancient-data.org) is a website with a search engine for the Hebrew Bible, powered by the
[BHSA](https://github.com/ETCBC/bhsa) linguistic database, also known as ETCBC or WIVU.

Read all about SHEBANQ on the [wiki](https://github.com/ETCBC/shebanq/wiki) of this repository.
There you find information on the data sources as well.
And there are the [techdocs](https://etcbc.github.io/shebanq/) of course.

## History

See [Changes](https://github.com/ETCBC/shebanq/wiki/Changes)
